// 2013-01-28

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

unit u_09_vcl_styles;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Menus, Vcl.ImgList;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Memo1: TMemo;
    PopupMenu1: TPopupMenu;
    red1: TMenuItem;
    green1: TMenuItem;
    blue1: TMenuItem;
    ImageList1: TImageList;
    Panel5: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    CheckBox1: TCheckBox;
    ScrollBar1: TScrollBar;
    TreeView1: TTreeView;
    ListView1: TListView;
    Panel7: TPanel;
    list_BDSUSERDIR_vsf_styles_: TButton;
    vsf_style_listbox_: TListBox;
    Splitter1: TSplitter;
    Panel4: TPanel;
    list_registered_styles_: TButton;
    registered_styles_listbox_: TListBox;
    Label1: TLabel;
    CheckBox2: TCheckBox;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure red1Click(Sender: TObject);
    procedure list_registered_styles_Click(Sender: TObject);
    procedure list_BDSUSERDIR_vsf_styles_Click(Sender: TObject);
    procedure registered_styles_listbox_Click(Sender: TObject);
    procedure vsf_style_listbox_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses Vcl.Styles, Vcl.Themes
       , u_display_simple
       , u_styles_helpers
       ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end;

    procedure TForm1.list_BDSUSERDIR_vsf_styles_Click(Sender: TObject);
      begin
        list_BDSUSERDIR_vsf_files(vsf_style_listbox_.Items);
      end; // list_registered_styles

    procedure TForm1.list_registered_styles_Click(Sender: TObject);
      begin
        list_registered_styles(registered_styles_listbox_.Items);
      end; // list_registered_styles_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
       Memo1.LInes.Clear;
      end;

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end;

    procedure TForm1.red1Click(Sender: TObject);
      begin
        Panel1.Color:= clRed;
      end; // red1Click

    procedure TForm1.vsf_style_listbox_Click(Sender: TObject);
      var l_vsf_filename: String;
      begin
        with vsf_style_listbox_ do
        begin
          if ItemIndex< 0
            then begin
                display('*** no vsf selected');
                Exit;
              end
            else l_vsf_filename:= Items[ItemIndex];

          load_BDSUSERDIR_vsf_style(k_BDSUSERDIR+ 'styles\'+ l_vsf_filename);

          // -- remove from vsf name list
          Items.Delete(ItemIndex);
        end;

        // -- redisplay the registered styles
        list_registered_styles_Click(Nil);
      end; // vsf_style_listbox_Click

    procedure TForm1.registered_styles_listbox_Click(Sender: TObject);
      var l_style_name: String;
      begin
        with registered_styles_listbox_ do
          l_style_name:= Items[ItemIndex];

        TStyleManager.SetStyle(l_style_name);
        get_style_info(l_style_name, ListView1, ImageList1);
      end; // registered_styles_listbox_Click

end.
